/***************************************************************************
 *   Copyright (C) 2006 by Raul Fernandes                                  *
 *   rgfbr@yahoo.com.br                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _DICTIONARIESSETTINGS_H_
#define _DICTIONARIESSETTINGS_H_

#include "dictionariessettingsbase.h"

class KTranslatorDictionaryManager;
class KPassivePopup;

class DictionariesSettings : public DictionariesSettingsBase
{
Q_OBJECT
public:
  DictionariesSettings( KTranslatorDictionaryManager*, QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
  ~DictionariesSettings();

public slots:
  void addDictionary();

  void editDictionary();

  void removeDictionary();

  void moveDictionaryUp();

  void moveDictionaryDown();

  void showDicTip( QListBoxItem * );

  void hideDicTip();

private:
  KTranslatorDictionaryManager *plugins;
  KPassivePopup *dicPopup;
};

#endif // _DICTIONARIESSETTINGS_H_
